/**
* Classe dimostrativa per oggetti di tipo Televisore
* @author F. F.
* @version 1.0
*/
public class Televisore {
 private int pollici;
 private String schermo;
 private String colore;
 private int canale;
 private int volume;
 private int luminosita;
 private boolean acceso;
 /**
 * Crea un televisore con valori iniziali relativi a
 * numero di pollici, tipologia di schermo e colore esterno
 * gli attributi di stato sono impostati di default a:
 * canale=1, volume=10, luminosita'=40, acceso=false
 * @param pollici numero di pollici
 * @param schermo tipologia di schermo (LCD, LED, )
 * @param colore colore esterno del televisore (Nero, Bianco, )
 */
 public Televisore(int pollici, String schermo, String colore) {
  setPollici(pollici);
  setSchermo(schermo);
  setColore(colore);
  canale = 1;
  volume = 10;
  luminosita = 40;
  acceso = false;
 }
 
/**
* restituisce il numero di pollici del televisore
*/
 public int getPollici() {return pollici;}
 
/**
* imposta il numero di pollici del televisore
* @param p dimensione in pollici
*/
 private void setPollici(int p) {pollici = p;}
 
/**
* restituisce il colore esterno del televisore
*/
 public String getColore() {return colore;}
 
/**
* imposta il colore esterno del televisore
* @param c colore
*/
 private void setColore(String c) {colore = c;}
 
/**
* restituisce la tipologia di schermo del televisore
*/
 public String getSchermo() {return schermo;}
 
/**
* imposta la tipologia di schermo del televisore
* @param s tipo di schermo
*/
 private void setSchermo(String s) {schermo = s;}
 
/**
* restituisce il canale selezionato
*/
 public int getCanale() {return canale;}
 
/**
* imposta direttamente un numero di canale
* @param c valore numerico del canale (1-99)
*/
 public void setCanale(int c) {if (c>0 && c<99) canale = c;}
 
/**
* restituisce il livello di volume impostato
*/
 public int getVolume() {return volume;}
 
/**
* restituisce il livello di luminosita' impostato
*/
 public int getLuminosita() {return luminosita;}
 
/**
* restituisce lo stato acceso/spento impostato
*/
 public boolean isAcceso() {return acceso;}
 
/**
* imposta a true l'attributo acceso
*/
 public void accendi() {acceso = true;}
 
/**
* imposta a false l'attributo acceso
*/
 public void spegni() {acceso = false;}
 
/**
* incrementa il numero di canale
*/
 public void canaleSuccessivo() {
  if (canale<99) canale++;
 }
 
/**
* decrementa il numero di canale
*/
 public void canalePrecedente() {
  if (canale>0) canale--;
 }
 
/**
* incrementa il livello di volume
*/
 public void alzaVolume() {if (volume<50) volume++;}
 
/**
* decrementa il livello di volume
*/
public void abbassaVolume() {
 if (volume>0) volume--;
}

/**
* incrementa il livello di luminosit
*/
public void aumentaLuminosita() {
 if (luminosita<80) luminosita ++;
}

/**
* decrementa il livello di luminosit
*/
 public void diminuisceLuminosita() {
  if (luminosita>0) luminosita--;
 }
}